<?php
/**
 * EDUtwitter: Block for Moodle 2.2.1
 * 
 * 
 * @package  EDUtwitter
 * @author   David Romero Santos <david.romerosantos@alum.uca.es>
 * @license  http://opensource.org/licenses/gpl-license.php GNU Public License
 * @link     https://forja.rediris.es/projects/cusl6-edutweets/
 */

require_once('TwitterAPIExchange.php');

/**
* Split tweets longer than 140 characters
* 
* @param object $tweet
* @param string $status
*/
function split_tweet($tweet,$status) {
    /**
    * Publish the tweet if it isn't longer than 140 characters
    */ 
    if(strlen($status) <= '140'){
        $postfields = array('status' => $status);
        $tweet->setPostfields($postfields)
              ->performRequest();
    }else{
        $posicion = strpos($status," ",'137');
        $i=136;
        /**
        * Search for a blank space for split the tweet
        */ 
        while($posicion === false){
            $posicion = strpos($status," ",$i);
            $i--;
        }
        /**
        * Split and send the first part of the tweet
        */ 
        $status2 = substr($status,0,$posicion)."...";
        $postfields = array('status' => $status2);
        $response = $tweet->setPostfields($postfields)
                          ->performRequest();
        $salida = json_decode($response);
        if(!empty($salida->errors)){
            foreach($salida->errors as $error){
                if($error->code == '186'){
                    $i=$i-22;
                    $posicion = strpos($status," ",$i);
                    $status2 = substr($status,0,$posicion)."...";
                    $postfields = array('status' => $status2);
                    $tweet->setPostfields($postfields)
                          ->performRequest();                    
                 }
             }
        }
        /**
        * Add the hashtag and split the second part if it is longer than 140 characters
        */
        if($status[0] == '#'){
            $posicion_hash = strpos($status," ",0);
            $hashtag = substr($status,0,$posicion_hash);
            $status3 = $hashtag." ...".substr($status,$posicion+1,strlen($status)-1);
            split_tweet($tweet,$status3);
        } else {
            $status3 = "...".substr($status,$posicion+1,strlen($status)-1);
            split_tweet($tweet,$status3);
        }
    }
}
